/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: copyout.c,v 1.4 2005/07/04 21:46:54 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include "getCGIparm.h"

int
getCGIparmcopy( u_int32_t flags
    , const u_char * query
    , const u_char * const tofind
    , const u_char * const query_delimit
    , const u_char * const null_sign
    , int dout
    ) {
    u_char *unescaped, *p, *q, *f1, *f2;
    int i, ex = EX_OK;
    const u_char *empty = "";
    int out;
    FILE *outf;

    if  (!query_delimit || !null_sign) return(EX_DATAERR);
    if  ((out = dup(dout)) < 0) {
        ifBLIN_QV1(flags) warn("Can\'t dup out file in getCGIparmcopy");
        return(-1);
    }
    if  (!(outf = fdopen(out, "a"))) {
        ifBLIN_QV1(flags) warn("Can\'t open out file in getCGIparmcopy");
        return(-1);
    }
    ifBLIN_QV3(flags)
        fprintf( stderr
               , "CP flags=%08X, query=%s~, tofind=%s~, query_delimit=%s~, null_sign=%s~\n"
               , flags
               , query ? query : empty
               , tofind ? tofind : empty
               , query_delimit
               , null_sign
               );
    if  (query) {
    ;   if  (!(unescaped = malloc(strlen(query) + 1)))                             return(EX_TEMPFAIL);
    ;   f1 = f2 = q = NULL;

    ;   for (i = 0; !ex; i++) {
    ;   ;   f1 = f2 = q = NULL;
    ;   ;   p = unescaped;
    ;   ;   ex = getCGIparmpass1(flags, &query, NULL, p);
    ;   ;   ifBLIN_QV4(flags) fprintf(stderr, "pass1 = %d\n", ex);
    ;   ;   if  (ex > 0) break;
    ;   ;   ifBLIN_QV4(flags) fprintf(stderr, "p=%s~\n", p);
    ;   ;   if (ex < 0) {
    ;   ;       p[-ex - 1] = '\0';
    ;   ;       q = index(p, '\0') + 1;
    ;   ;       ex = 0;
    ;   ;       ifBLIN_QV4(flags) fprintf(stderr, "p=%s~ q=%s~\n", p, q);
    ;   ;   } else {
    ;   ;       q = p;
    ;   ;       p = NULL;
    ;   ;       ifBLIN_QV4(flags) fprintf(stderr, "p=NULL q=%s~\n", q);
    ;   ;   }
    ;   ;   if  (!(ex = getCGIparmpass2(flags, tofind, q)) && ~flags & gCGI_OTST) {
    ;   ;       f1 = p;
    ;   ;       if  (p && (ex = getCGIparmpass3(flags, "copy", &p))) break;
    ;   ;       f2 = q;
    ;   ;       if  ((ex = getCGIparmpass3(flags, "copy", &q))) break;
    ;   ;       if  (flags & gCGI_RNUM) fprintf(outf, "%d%s", i, query_delimit);
    ;   ;       if  (!p) fprintf(outf, "%s%s", null_sign, query_delimit);
                  else fprintf(outf, "%s%s", p, query_delimit);
    ;   ;       fprintf(outf, "%s\n", q);
    ;   ;       if  (p && p != f1) {free(p); p = NULL;}
    ;   ;       if  (q && q != f2) {free(q); q = NULL;}
    ;   ;   }
    ;   ;   if  (ex > 0 || *query++ != '&') break;
    ;   }
    ;   if  (p && f1 && p != f1) free(p);
    ;   if  (q && f2 && q != f2) free(q);
    ;   free(unescaped);
    }
    if  (!ex) fprintf(outf, "\\.\n");
    ifBLIN_QV3(flags) fprintf(stderr, "CP ex=%d\n", ex);
    fclose(outf);
    return(ex);
}
